package odbc

import (
	"context"

	"git.wecise.com/wecise/odb-go/odb"
)

func SubscribeDataChangeTest(client odb.Client) {
	SubscribeTest(client, "CLASS_DATA_CHANGE:/")
	SubscribeTest(client, "META_DATA_CHANGE:/")
}

func SubscribeTest(client odb.Client, topic string) {
	sub := client.Subscribe(context.Background(), topic)
	go func() {
		defer func() {
			if err := sub.Unsubscribe(context.Background()); err != nil {
				log.Error(err)
				return
			}
		}()
		for m := range sub.Channel() {
			string_message := m.EventData().String()
			log.Info(topic + " received " + topic + " message " + "\n" + string_message)
		}
	}()
}
